﻿local broker = LibStub("LibDataBroker-1.1")
local L = LibStub:GetLibrary( "AceLocale-3.0" ):GetLocale( "Broker_PvP" )

local PvP = broker:NewDataObject(L["Broker_PvP"], {type = "data source", icon = "Interface\\PVPFrame\\\PVP-ArenaPoints-Icon", label = "PvP"})
LibStub("AceEvent-3.0"):Embed(PvP)

local onUpdateFrame = CreateFrame("Frame")
onUpdateFrame:Hide()

function PvP:Update()
	local status, queued, confirm, active
	self.status = nil
	
	for i=1, MAX_BATTLEFIELD_QUEUES do
		status = GetBattlefieldStatus(i)
		if ( status ~= "none" ) then
			if ( status == "queued" ) then
				queued = true
			elseif ( status == "confirm" ) then
				confirm = true
			elseif ( status == "active" ) then
				self.status = true
			end
		end
	end
	if confirm then
		self.text = L["Confirm"]
	elseif queued then
		self.text = L["Queued"]
	elseif self.status then
		self.text = L["Active"]
	else
		self.text = L["No Queue"]
	end
end

function PvP.OnClick(frame, button)
	GameTooltip:Hide()
	if ( PvP.status ) then
		if ( button == "RightButton" ) then
			ToggleDropDownMenu(1, nil, MiniMapBattlefieldDropDown, frame)
		elseif ( IsShiftKeyDown() ) then
			ToggleBattlefieldMinimap()
		else
			ToggleWorldStateScoreFrame()
		end
	elseif ( button == "RightButton" ) then
		ToggleDropDownMenu(1, nil, MiniMapBattlefieldDropDown, frame)
	end
end

local owner
function PvP.OnEnter(frame)
	GameTooltip:SetOwner(frame, "ANCHOR_CURSOR")
	owner = true
	if (MiniMapBattlefieldFrame.tooltip) then
		GameTooltip:SetText(MiniMapBattlefieldFrame.tooltip)
	else
		GameTooltip:SetText(L["No Queues"])
	end
	onUpdateFrame:Show()
end

function PvP.OnLeave()
	onUpdateFrame:Hide()
	GameTooltip:Hide()
	owner = nil
end

function PvP:UPDATE_BATTLEFIELD_STATUS()
	self:Update()
	if MiniMapBattlefieldFrame:IsVisible() then
		MiniMapBattlefieldFrame:Hide()
	end
end

local function onUpdate()
	if owner then
		BattlefieldFrame_UpdateStatus(1)
		if (MiniMapBattlefieldFrame.tooltip) then
			GameTooltip:SetText(MiniMapBattlefieldFrame.tooltip)
		else
			GameTooltip:SetText(L["No Queues"])
		end
	end
end

onUpdateFrame:SetScript("OnUpdate",onUpdate)
PvP:RegisterEvent("UPDATE_BATTLEFIELD_STATUS")
PvP:Update()